
' Example of scrolling layers
'
' Mike Wiering, Wiering Software (www.wieringsoftware.nl)
'
' To generate the files Back1TileSet.bmx and L1TileSet.bmx (and .png):
' load Demo.tsp in Tile Studio (tilestudio.sf.net) and generate code (F10)


Import "TileMap.bmx"

AppTitle$ = "Tile Map Demo"

Const SCREEN_W = 640
Const SCREEN_H = 480

Graphics (SCREEN_W, SCREEN_H, 0)

' background tileset (named "BACK1" in Demo.tsp)
Include "Back1TileSet.bmx"
Local BGTileSet: TTileSet = CreateBack1 ()
Local BGLayer: TLayer = CreateBack1BackGr1 (BGTileSet)

BGLayer.ShiftY = 20   ' shift the background up a little

BGLayer.HorzRepPat = MRP_TILE    ' background repeats horizontally
BGLayer.VertRepPat = MRP_EXTEND  ' extend vertically

' foreground tileset (named "L1")
Include "L1TileSet.bmx"
Local FGTileSet: TTileSet = CreateL1 ()
Local FGLayer: TLayer = CreateL1Level1 (FGTileSet)

Local X = 0, Y = 0
Local XSpeed = 1, YSpeed = 1
Local W, H

SetScale (1.25, 1.25)

Repeat
  Cls

  If X + XSpeed < 0 Then XSpeed = -XSpeed
  If Y + YSpeed < 0 Then YSpeed = -YSpeed
  FGLayer.GetMapSize (W, H)
  If X + XSpeed > W - SCREEN_W Then XSpeed = -XSpeed
  If Y + YSpeed > H - SCREEN_H Then YSpeed = -YSpeed
    
  X :+ XSpeed
  Y :+ YSpeed

  BGLayer.ScrollTo (X / 3, Y / 3)  ' background scrolls at 1/3rd speed
  FGLayer.ScrollTo (X, Y)

  BGLayer.Draw ()
  FGLayer.Draw ()

  Flip ()
Until KeyHit (KEY_ESCAPE) Or AppTerminate ()

